//
// Rules.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Rules: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var ruleEnabledYN: Bool?
    public var fieldKeyNumeric: Double?
    public var ruleKeyNumeric: Double?
    public var ruleOrder: Double?
    public var fieldKey: String?
    public var fieldName: String?
    public var originatingSystemID: Double?
    public var originatingSystemName: String?
    public var originatingSystemRuleKey: String?
    public var ruleAction: String?
    public var ruleDescription: String?
    public var ruleErrorText: String?
    public var ruleExpression: String?
    public var ruleHelpText: String?
    public var ruleKey: String?
    public var ruleName: String?
    public var ruleVersion: String?
    public var ruleWarningText: String?
    public var sourceSystemHistoryKey: String?
    public var sourceSystemID: String?
    public var sourceSystemName: String?
    public var className: String?
    public var resourceName: String?
    public var ruleFormat: String?
    public var ruleType: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?

    public init(id: Int? = nil, ruleEnabledYN: Bool? = nil, fieldKeyNumeric: Double? = nil, ruleKeyNumeric: Double? = nil, ruleOrder: Double? = nil, fieldKey: String? = nil, fieldName: String? = nil, originatingSystemID: Double? = nil, originatingSystemName: String? = nil, originatingSystemRuleKey: String? = nil, ruleAction: String? = nil, ruleDescription: String? = nil, ruleErrorText: String? = nil, ruleExpression: String? = nil, ruleHelpText: String? = nil, ruleKey: String? = nil, ruleName: String? = nil, ruleVersion: String? = nil, ruleWarningText: String? = nil, sourceSystemHistoryKey: String? = nil, sourceSystemID: String? = nil, sourceSystemName: String? = nil, className: String? = nil, resourceName: String? = nil, ruleFormat: String? = nil, ruleType: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil) {
        self.id = id
        self.ruleEnabledYN = ruleEnabledYN
        self.fieldKeyNumeric = fieldKeyNumeric
        self.ruleKeyNumeric = ruleKeyNumeric
        self.ruleOrder = ruleOrder
        self.fieldKey = fieldKey
        self.fieldName = fieldName
        self.originatingSystemID = originatingSystemID
        self.originatingSystemName = originatingSystemName
        self.originatingSystemRuleKey = originatingSystemRuleKey
        self.ruleAction = ruleAction
        self.ruleDescription = ruleDescription
        self.ruleErrorText = ruleErrorText
        self.ruleExpression = ruleExpression
        self.ruleHelpText = ruleHelpText
        self.ruleKey = ruleKey
        self.ruleName = ruleName
        self.ruleVersion = ruleVersion
        self.ruleWarningText = ruleWarningText
        self.sourceSystemHistoryKey = sourceSystemHistoryKey
        self.sourceSystemID = sourceSystemID
        self.sourceSystemName = sourceSystemName
        self.className = className
        self.resourceName = resourceName
        self.ruleFormat = ruleFormat
        self.ruleType = ruleType
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case ruleEnabledYN = "RuleEnabledYN"
        case fieldKeyNumeric = "FieldKeyNumeric"
        case ruleKeyNumeric = "RuleKeyNumeric"
        case ruleOrder = "RuleOrder"
        case fieldKey = "FieldKey"
        case fieldName = "FieldName"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemName = "OriginatingSystemName"
        case originatingSystemRuleKey = "OriginatingSystemRuleKey"
        case ruleAction = "RuleAction"
        case ruleDescription = "RuleDescription"
        case ruleErrorText = "RuleErrorText"
        case ruleExpression = "RuleExpression"
        case ruleHelpText = "RuleHelpText"
        case ruleKey = "RuleKey"
        case ruleName = "RuleName"
        case ruleVersion = "RuleVersion"
        case ruleWarningText = "RuleWarningText"
        case sourceSystemHistoryKey = "SourceSystemHistoryKey"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemName = "SourceSystemName"
        case className = "ClassName"
        case resourceName = "ResourceName"
        case ruleFormat = "RuleFormat"
        case ruleType = "RuleType"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(ruleEnabledYN, forKey: .ruleEnabledYN)
        try container.encodeIfPresent(fieldKeyNumeric, forKey: .fieldKeyNumeric)
        try container.encodeIfPresent(ruleKeyNumeric, forKey: .ruleKeyNumeric)
        try container.encodeIfPresent(ruleOrder, forKey: .ruleOrder)
        try container.encodeIfPresent(fieldKey, forKey: .fieldKey)
        try container.encodeIfPresent(fieldName, forKey: .fieldName)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(originatingSystemRuleKey, forKey: .originatingSystemRuleKey)
        try container.encodeIfPresent(ruleAction, forKey: .ruleAction)
        try container.encodeIfPresent(ruleDescription, forKey: .ruleDescription)
        try container.encodeIfPresent(ruleErrorText, forKey: .ruleErrorText)
        try container.encodeIfPresent(ruleExpression, forKey: .ruleExpression)
        try container.encodeIfPresent(ruleHelpText, forKey: .ruleHelpText)
        try container.encodeIfPresent(ruleKey, forKey: .ruleKey)
        try container.encodeIfPresent(ruleName, forKey: .ruleName)
        try container.encodeIfPresent(ruleVersion, forKey: .ruleVersion)
        try container.encodeIfPresent(ruleWarningText, forKey: .ruleWarningText)
        try container.encodeIfPresent(sourceSystemHistoryKey, forKey: .sourceSystemHistoryKey)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(ruleFormat, forKey: .ruleFormat)
        try container.encodeIfPresent(ruleType, forKey: .ruleType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
    }
}

